---
title: Updating web applications for Firefox 3
slug: Mozilla/Firefox/Releases/3/Updating_web_applications
tags:
  - Firefox 3
---
<div>{{FirefoxSidebar}}</div>

<div>{{Fx_minversion_header(3)}}</div>

<p>There are a number of changes in the upcoming Firefox 3 that may affect your web site or web application, as well as new features you may wish to take advantage of. This article will serve as a starting point as you work on updating your content to take the fullest possible advantage of Firefox 3.</p>

<h2 id="DOM_changes">DOM changes</h2>

<p>Nodes from external documents should be cloned using <a href="/en-US/docs/Web/API/Document/importNode" title="The Document object's importNode() method creates a copy of a Node or DocumentFragment from another document, to be inserted into the current document later."><code>document.importNode()</code></a> (or adopted using <a href="/en-US/docs/Web/API/Document/adoptNode" title="Document.adoptNode() transfers a node from another document into the method's document. The adopted node and its subtree is removed from its original document (if any), and its ownerDocument is changed to the current document. The node can then be inserted into the current document."><code>document.adoptNode()</code></a>) before they
    can be inserted into the current document. For more on the <a href="/en-US/docs/Web/API/Node/ownerDocument" title="The Node.ownerDocument read-only property returns the top-level document object for this node."><code>Node.ownerDocument</code></a> issues, see the
    <a class="external" href="http://www.w3.org/DOM/faq.html#ownerdoc" rel="noopener">W3C DOM FAQ</a>.</p>

    <p>Firefox doesn't currently enforce this rule (it did for a while during the development of Firefox 3, but too many
    sites break when this rule is enforced). We encourage Web developers to fix their code to follow this rule for
    improved future compatibility.</p>

<h2 id="HTML_changes">HTML changes</h2>

<h3 id="Changes_to_character_set_inheritance">Changes to character set inheritance</h3>

<p>Firefox 3 closes a security bug in frames and iframes that allowed them to inherit the parent's character set. This could cause problems in certain cases. Now, frames are only allowed to inherit the parent's character set if both frame and parent were loaded from the same server. If you have pages that assume that frames loaded from other servers will inherit the same character set, you should update the frames' HTML to indicate their character set specifically.</p>

<h3 id="Change_to_the_SCRIPT_element">Change to the SCRIPT element</h3>

<p>The <code><span class="nowiki">&lt;script&gt;</span></code> element in <code>text/html</code> documents now requires a closing <code><span class="nowiki">&lt;/script&gt;</span></code> in HTML 4 documents, even if you're not including any content in between. While in previous versions of Firefox, you could do:</p>

<pre>&lt;script ... /&gt;
</pre>

<p>Now the markup must comply with the HTML specifications (if it's actually HTML), and hence you must actually close it, like this:</p>

<pre>&lt;script ...&gt;&lt;/script&gt;
</pre>

<p>This improves both compatibility and security.</p>

<h2 id="CSS_changes">CSS changes</h2>

<h3 id="Change_to_font-size_based_on_em_ex_units">Change to font-size based on em, ex units</h3>

<p>font-size values in em and ex units used to be affected by the user's minimum font size setting: if a font was displayed larger due to the minimum font size, the em and ex units for font-size settings based on this one would be enlarged accordingly. This was inconsistent with the way percentage-based font sizes behaved.</p>

<p>font-size values in em and ex units are now based on an "intended font size" that is not affected by the user's minimum font size. In other words, font sizes are always calculated according to the designer's intention and are adjusted for minimum font size afterwards.</p>

<p>See {{Bug(434718)}}, especially its <span class="comment">NOT A CASE FOR THE BUG TEMPLATE - The following link points to a Bugzilla attachment, not a Bugzilla bug; if you use the attachment number as a bug number, it becomes nonsense</span> <a class="link-https" href="https://bugzilla.mozilla.org/attachment.cgi?id=322943">attachment 322943</a><span class="comment">NOT A CASE FOR THE BUG TEMPLATE</span> for a demonstration (must be watched with a minimum font size &gt;= 6 to see the difference: the two box cascades behave differently in Firefox 2, because the em-based font-size "bounces" off the minimum font size).</p>

<h2 id="Security_changes">Security changes</h2>

<h3 id="Chrome_access">Chrome access</h3>

<p>In prior versions of Firefox, any web page could load scripts or images from chrome using the <code>chrome://</code> protocol. Among other things, this made it possible for sites to detect the presence of add-ons -- which could be used to breach a user's security by bypassing add-ons that add security features to the browser.</p>

<p>Firefox 3 only allows web content to access items in the <code><a rel="freelink">chrome://browser/</a></code> and <code><a rel="freelink">chrome://toolkit/</a></code> spaces. These files are intended to be accessible by web content. All other chrome content is now blocked from access by the web.</p>

<p>There is, however, a way for extensions to make their content web-accessible. They can specify a special flag in their <code>chrome.manifest</code> file, like this:</p>

<pre>content mypackage location/ contentaccessible=yes
</pre>

<p>This shouldn't be something you need to do very often, but it's available for those rare cases in which it's needed. Note that it's possible that Firefox may alert the user that your extension uses the <code>contentaccessible</code> flag in this way, as it does constitute a potential security risk.</p>

<div class="note"><strong>Note:</strong> Because Firefox 2 doesn't understand the <code>contentaccessible</code> flag (it will ignore the entire line containing the flag), if you want your add-on to be compatible with both Firefox 2 and Firefox 3, you should do something like this:

<pre>content mypackage location/
content mypackage location/ contentaccessible=yes
</pre>
</div>

<h3 id="File_upload_fields">File upload fields</h3>

<p>In prior versions of Firefox, there were cases in which when the user submitted a file for uploading, the entire path of the file was available to the web application. This privacy concern has been resolved in Firefox 3; now only the filename itself is available to the web application.</p>

<h3 id="Using_remote_JARs_in_frames">Using remote JARs in frames</h3>

<p>Using code in JAR fiels loaded from other domains is no longer allowed in frames; this mitigates a <a href="http://www.mozilla.org/security/announce/2008/mfsa2008-23.html">potential attack vector</a>.</p>

<h3 id="Changes_to_same-origin_policy_for_file_URIs">Changes to same-origin policy for file: URIs</h3>

<p>The same-origin policy for file: URIs has changed in Firefox 3. This may affect your content; please see <a href="/en-US/docs/Same-origin_policy_for_file:_URIs" title="Same-origin policy for file: URIs">Same-origin policy for file: URIs</a> for details.</p>

<h2 id="JavaScript_changes">JavaScript changes</h2>

<p>Firefox 3 supports <a href="/en-US/docs/New_in_JavaScript_1.8" title="New_in_JavaScript_1.8">JavaScript 1.8</a>. One important change that may require updates to your web site or application is that the obsolete and non-standard <code>Script</code> object is no longer supported. This is not the <code><span class="nowiki">&lt;script&gt;</span></code> tag, but a JavaScript object that was never standardized. It is unlikely this is something you ever used anyway, so you're probably fine.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Firefox_3_for_developers" title="Firefox_3_for_developers">Firefox 3 for developers</a></li>
 <li><a href="/en-US/docs/New_in_JavaScript_1.8" title="New_in_JavaScript_1.8">New in JavaScript 1.8</a></li>
 <li><a href="/en-US/docs/Updating_extensions_for_Firefox_3" title="Updating_extensions_for_Firefox_3">Updating extensions for Firefox 3</a></li>
</ul>
